//Written by David_G

import processing.serial.*;

Serial myPort;
int myport,mybaud;
String portName;

int serial_position;
String serial_buffer;
boolean serial_ready;
  
void MySerial(int port, int baud) { 
  setport(port);
  setbaud(baud);
  portName = Serial.list()[port];
  println(Serial.list());
  println("Setting serial to " + portName + " at baud " + mybaud);
  myPort = new Serial(this, portName, mybaud);
  serial_buffer = "";
  serial_ready = false;
}

void setport(int port) { myport = port; }
void setbaud(int baud) { mybaud = baud; }

//interrupt serial event
void serialEvent(Serial myPort) {
   char bit = char(myPort.read());
   serial_buffer = serial_buffer + bit;
   //println("Serial event: " + bit);
   if(bit == ';') {
     println("Serial command: " + serial_buffer);
     serial_ready = true; 
   }
}

//test the serial buffer to see if there is anything there
boolean poll_serial() {
  return serial_ready;
}

boolean wait_serial(String cmd) {
  while(!poll_serial()) {delay(10);}
  while(!strcmp(Serial_buffer(), cmd, 0)) { 
    println("Did not get command " + Serial_buffer() + " != " + cmd); 
    delay(1000);
    while(!poll_serial()) {delay(1000);}
    //println("Terminate...");
    //return false;
  } 
  //got comman we were expectig.. reset serial events
  serial_buffer = "";
  serial_ready = false;  
  return true;
}

void serial_command(String cmd, String wait) {
  cmd = cmd + ";";
  wait = wait + ";";
  println("Sending command: " + cmd);
  myPort.write(cmd);
  println("Waiting for: " + wait); 
  wait_serial(wait);  
}

float serial_temp() {
   println("Sending temp command");
   myPort.write("r;");
   while(!poll_serial()) {delay(10);}
   String val = serial_buffer.substring(2,serial_buffer.length()-1);
   serial_buffer = "";
   serial_ready = false;
   
   myPort.write("r;");
   while(!poll_serial()) {delay(10);}
   String val2 = serial_buffer.substring(2,serial_buffer.length()-1);
   serial_buffer = "";
   serial_ready = false;
   
   while(!val.equals(val2)) {     
     println("Temp correction needed: " + val + " != " + val2);
     myPort.write("r;");
     while(!poll_serial()) {delay(10);}
     val2 = val;
     val = serial_buffer.substring(2,serial_buffer.length()-1);   
     serial_buffer = "";
     serial_ready = false;     
   }
   println("Got " + val);
   serial_buffer = "";
   serial_ready = false;  
   return Float.parseFloat(val);
}

boolean strcmp(String msg, String srch, int offset) {
  int chars = srch.length();
  if(msg == null || srch == null) return false;
  if(chars > srch.length() || chars > msg.length()) return false;
  for(int i=offset; i < chars; i++) {
    if(srch.charAt(i) != msg.charAt(i)) return false;
  }
  return true;
}

//retuns the buffer
String Serial_buffer() {
   return serial_buffer; 
}
