//Writted by David_G

int size=50;
float [][] values;
float pan,tilt,ppan,ptilt;
float pan_min,tilt_min,pan_max,tilt_max;
int mx,my,incx,incy;
int moves = 0;
String inBuffer;

void setup() {  
  size(size*20,size*20); //colls, rows
  //measure in 10deg increments 
  values = new float[height/size][width/size];
  frameRate(1.2);
  for(int y=0; y < height/size-1; y++) {
     for(int x=0; x < width/size-1; x++) {
       values[y][x] = -1;
     }
  }
  pan_min=60;
  pan_max=100;
  pan=(pan_max-pan_min)/((width/size-1)/1.0);
  
  tilt_min=40;
  tilt_max=70;
  tilt=(tilt_max-tilt_min)/((height/size-1)/1.0);
  incy = incx = 1;
  mx = my = 0;
  ppan=ptilt=0;
  
  println("Init system");
  MySerial(0, 9600);
  //wait for ready signal (first srial signal)
  wait_serial(";");
  println("Serial is rady");
  println("Starting init position");
  pan();
  while(serial_temp() == 99.0) {delay(100);}
  println("End init");
}



void draw() {
  //take a measurement
  values[my][mx] = random(30,75);
  values[my][mx] = serial_temp();
  draw_grid();
  inc_line();
  draw_line();  
}

//draw the measurement grid
void draw_grid() {   
  //figure out min/max from the grid
  float min,max;
  max = min = values[0][0];
  int llx,lly,urx,ury;
  
  for(int y=0; y < height/size-1; y++) {
     for(int x=0; x < width/size-1; x++) {
       if(values[y][x] == -1) { ; }  
       else {
         if(min > values[y][x]) { min = values[y][x]; }
         if(max < values[y][x]) { max = values[y][x]; }
       }
     }
  }
  
  background(255);
  smooth();
  for(int y=0; y < height/size-1; y++) {
     for(int x=0; x < width/size-1; x++) {
        //fill(255*(mouseX*1.0/width), 255*(mouseY*1.0/height),0);
        if(values[y][x] != -1) {
          float ratio = (values[y][x]-min)/(max-min);
          fill(255*(ratio),0,255*(1-ratio));
        }
        else { fill(255,255,255); }
        ellipse(x*size+size,y*size+size,size,size);
        if(values[y][x] != -1) {
          fill(0,0,0);  
          text(values[y][x],x*size+size/2,y*size+size);
        }
        
     } 
  }   
}

void inc_line() {
  mx+=incx;
  if(mx < 0) { incx = 1; my+=incy; mx=0; }
  if(mx >= width/size-1) { incx = -1; my+=incy; mx--;}
  if(my >= height/size-1) { incy = -1; my = height/size-3; }
  if(my < 0) { incy = 1; my=1; }
}

//draw target plot lines
void draw_line() {
  fill(0,0,0);
  strokeWeight(2);
  line(mx*size+size,0,mx*size+size,height);
  line(0,my*size+size,width,my*size+size);
  strokeWeight(1);  
  pan();
}



